#!/bin/sh

tmp=/tmp/test_cle.tmp

if [ ! -e ./cle ] ; then
    echo ./cle is missing
    exit 1
fi

for size in 5 6 7 ; do
    for trial in a b c d e f ; do
	tstem=testdata/T$size$trial
	ostem=testdata/out$size$trial
	rm -f $tmp $ostem.mst $ostem.msf

	# MST trial
	if ! ./cle $tstem.mtx $size > $tmp ; then
	    echo CLE MST failed for $tstem
	    exit 1
	fi
	cat $tmp | tail -$size | cut -d\  -f3 > $ostem.mst
	echo -n "$size $trial MST "
	./numeric_diff.pl -r $tstem.mst $ostem.mst > /dev/null

	# MSF trial
	if ! ./cle $tstem.mtx $size multiroot > $tmp ; then
	    echo CLE MSF failed for $tstem
	    exit 1
	fi
	cat $tmp | tail -$size | cut -d\  -f3 > $ostem.msf
	echo -n "$size $trial MSF "
	./numeric_diff.pl -r $tstem.msf $ostem.msf > /dev/null
    done
done
