#!/bin/sh

tmp=/tmp/test_det_inv.tmp

if [ ! -e ./test_det_inv ] ; then
    echo ./test_det_inv is missing
    exit 1
fi

for size in 5 20 100 ; do
    for trial in a b c ; do
	stem=testdata/A$size$trial
	ostem=testdata/out$size$trial
	rm -f $tmp $ostem.det $ostem.inv
	if ! ./test_det_inv $stem.mtx $size > $tmp ; then
	    echo test_det_inv failed for $stem
	    exit 1
	fi
	cat $tmp | head -1 > $ostem.det
	cat $tmp | tail -$size > $ostem.inv
	echo -n "$size $trial DET "
	./numeric_diff.pl -r $stem.det $ostem.det > /dev/null
	echo -n "$size $trial INV "
	./numeric_diff.pl -r $stem.inv $ostem.inv > /dev/null
    done
done
