#!/bin/sh

tmp=/tmp/test_par_mar.tmp

if [ ! -e ./test_st_par_mar ] ; then
    echo ./test_st_par_mar is missing
    exit 1
fi

for size in 5 20 100 ; do
    for trial in a b c ; do
	astem=testdata/A$size$trial
	gstem=testdata/G$size$trial
	fstem=testdata/F$size$trial
	ostem=testdata/out$size$trial

	# spanning-tree tests
	rm -f $tmp $ostem.st.par $ostem.st.pr2 $ostem.st.mar
	if ! ./test_st_par_mar $astem.mtx $size > $tmp ; then
	    echo test_st_par_mar failed for $gstem
	    exit 1
	fi
	cat $tmp | head -1 > $ostem.st.par
	cat $tmp | head -2 | tail -1 > $ostem.st.pr2
	cat $tmp | tail -$size > $ostem.st.mar
	echo -n "$size $trial ST PAR "
	( ./numeric_diff.pl -r $gstem.par $ostem.st.par 1>/dev/null ) 2>&1
	echo -n "$size $trial ST PR2 "
	( ./numeric_diff.pl -r $gstem.par $ostem.st.pr2 1>/dev/null ) 2>&1
	echo -n "$size $trial ST MAR "
	( ./numeric_diff.pl -r $gstem.mar $ostem.st.mar 1>/dev/null ) 2>&1

	# spanning-forest tests
	rm -f $tmp $ostem.sf.par $ostem.sf.pr2 $ostem.sf.mar
	if ! ./test_sf_par_mar $astem.mtx $size > $tmp ; then
	    echo test_sf_par_mar failed for $fstem
	    exit 1
	fi
	cat $tmp | head -1 > $ostem.sf.par
	cat $tmp | head -2 | tail -1 > $ostem.sf.pr2
	cat $tmp | tail -$size > $ostem.sf.mar
	echo -n "$size $trial SF PAR "
	( ./numeric_diff.pl -r $fstem.par $ostem.sf.par 1>/dev/null ) 2>&1
	echo -n "$size $trial SF PR2 "
	( ./numeric_diff.pl -r $fstem.par $ostem.sf.pr2 1>/dev/null ) 2>&1
	echo -n "$size $trial SF MAR "
	( ./numeric_diff.pl -r $fstem.mar $ostem.sf.mar 1>/dev/null ) 2>&1
    done
done
