#include <iostream>

#include <fstream>

#include <vector>

//#include <hash_map>

#include <set.h>

#include <map.h>

#include <multimap.h>

#include <list.h>

#include <hash_set.h>

#include <hash_map.h>

#include <assert.h>

#include <stdlib.h>

#include <math.h>

#include <string.h>


/* TERRY: the key difference seems to be the treatment of the root

node.  scoreMatrix is a n x n matrix of edge scores, but i don't

understand how the root-selection scores enter into the

computation.  in any case, once that's figured out i hope that

everything will work out.  i am confident that my matlab code is

working properly. */



typedef hash_map<int, int> TIntIntHashMap;

typedef list<TIntIntHashMap> TListIntIntHashMap;

using namespace std;



vector<int> get_keys(TIntIntHashMap hmap)

{
	
    vector<int> v;
	
    TIntIntHashMap::iterator pos;
	
    for (pos = hmap.begin(); pos!=hmap.end(); pos++)
		
        v.push_back(pos->first);
	
    return v;
	
}





TIntIntHashMap& chuLiuEdmonds(double **scoreMatrix, vector<bool> curr_nodes,
							  
							  int **oldI, int **oldO, TIntIntHashMap & final_edges, TIntIntHashMap *reps)

{
	
	
	
    // need to construct for each node list of nodes they represent (here only!)
	
	cout << "Curr Num Nodes: " << curr_nodes.size() << endl;
    vector<int> par(curr_nodes.size());
    int numWords = curr_nodes.size();
	
    // create best graph
    par[0] = -1;
    for(int i = 1; i < par.size(); i++) {
        // only interested in current nodes
        if(!curr_nodes[i]) continue;
        double maxScore = scoreMatrix[0][i];
        par[i] = 0;
        for(int j = 0; j < par.size(); j++) {
            if(j == i) continue;
            if(!curr_nodes[j]) continue;
            double newScore = scoreMatrix[j][i];
            if(newScore > maxScore) {
                maxScore = newScore;
                par[i] = j;
            }
        }
    }
	
	
    //Find a cycle
    // Define cycles to be a list of hashes (each hash is a cycle)
	
    TListIntIntHashMap cycles;
	
    vector<bool> added(numWords);
    for(int i = 0; i < numWords && cycles.size() == 0; i++) {
        // if I have already considered this or
        // This is not a valid node (i.e. has been contracted)
        if(added[i] || !curr_nodes[i])
            continue;
		
        added[i] = true;
        // Define cycle to be a hash of integers
        // loop
        TIntIntHashMap cycle; //= new TIntIntHashMap;
		cycle[i]=0;
		/* i think the basic approach is that they're just using
			"cycle" as a hash-set by hashing all nodes "l" to values of
			0.  "cycle" here is a hash-set that will contain the path
			that's been explored, starting from l = i.  a cycle is
			detected when "cycle" contains the next parent in the path.
			in this case, a *new* hash-set object is created and added
		to the list of cycles. */
		
        int l = i;
        while(true) {
            if(par[l] == -1) {
                added[l] = true;
                break;
            }
			
            if(cycle.find(par[l]) != cycle.end()) {
                TIntIntHashMap addcycle; //  = new TIntIntHashMap;
                int lorg = par[l];
				assert(lorg != -1);
                addcycle[lorg] = par[lorg];
                added[lorg] = true;
                int l1 = par[lorg];
                while(l1 != lorg) {
                    addcycle[l1]=par[l1];
                    added[l1] = true;
                    l1 = par[l1];
					assert(l1 != -1);
                }
                cycles.push_back(addcycle);
                break;
            }
            cycle[l] = 0;
            l = par[l];
            if (added[l] && (cycle.find(l) == cycle.end()))
                break;
            added[l] = true;
		}
	}
    // get all edges and return them
	
    if(cycles.empty()) {
        //System.out.println("TREE:");
        for(int i = 0; i < par.size(); i++) {
            if(!curr_nodes[i]) continue;
            if(par[i] != -1) {
                int pr = oldI[par[i]][i];
                int ch = oldO[par[i]][i];
                final_edges[ch] = pr;
            }
            else
                final_edges[0]=-1;
        }
        return final_edges;
    }
    int max_cyc = 0;
    TListIntIntHashMap::const_iterator wh_cyc;
    TListIntIntHashMap::const_iterator pos;
    for (pos =cycles.begin(); pos!= cycles.end(); ++pos) {
        if(pos->size() > max_cyc) {
            max_cyc = pos->size();
            wh_cyc = pos; // Will keep a point into the list
        }
    }
	
    TIntIntHashMap cycle  = *wh_cyc; // Focus on a specific cycle from now on (AMIR)
    vector<int> cyc_nodes = get_keys(cycle);
    int rep = cyc_nodes[0];
	
    double cyc_weight = 0.0;
    for(int j = 0; j < cyc_nodes.size(); j++) {
        cout << "Cyc: " << cyc_nodes[j] << " " << par[cyc_nodes[j]] << endl;
		cyc_weight += scoreMatrix[par[cyc_nodes[j]]][cyc_nodes[j]];
    }
	
    for(int i = 0; i < numWords; i++) {
        if (!curr_nodes[i] || (cycle.find(i)!=cycle.end()))
            continue;
        double max1 = -HUGE_VAL;
        int wh1 = -1;
        double max2 = -HUGE_VAL;
        int wh2 = -1;
		
        for(int j = 0; j < cyc_nodes.size(); j++) {
            int j1 = cyc_nodes[j];
			cout << "Score( " << j1 << "," << i << "):" << scoreMatrix[j1][i] << endl;
            if(scoreMatrix[j1][i] > max1 || j==0) {
                max1 = scoreMatrix[j1][i];
                wh1 = j1;//oldI[j1][i];
            }
			
            // cycle weight + new edge - removal of old
            double scr = cyc_weight + scoreMatrix[i][j1] - scoreMatrix[par[j1]][j1];
            if(scr > max2) {
                max2 = scr;
                wh2 = j1;//oldO[i][j1];
            }
        }
		
		
        cout << "Cycle Length Was " << cyc_nodes.size() << endl;	
        scoreMatrix[rep][i] = max1;
        oldI[rep][i] = oldI[wh1][i];//wh1;
			oldO[rep][i] = oldO[wh1][i];//oldO[wh1][i];
				scoreMatrix[i][rep] = max2;
				oldO[i][rep] = oldO[i][wh2];//wh2;
					oldI[i][rep] = oldI[i][wh2];//oldI[i][wh2];
						cout << "there" << endl;			
    }
	
	
	
	
    vector<TIntIntHashMap> rep_cons = vector<TIntIntHashMap>(cyc_nodes.size());
	
    for(int i = 0; i < cyc_nodes.size(); i++) {
        vector<int> keys = get_keys(reps[cyc_nodes[i]]);
        sort(keys.begin(),keys.end());
		
        for(int j = 0; j < keys.size(); j++)    {
            rep_cons[i][keys[j]] = 0;
        }
		
    }
	
	
    // don't consider not representative nodes
    // these nodes have been folded
    for(int i = 1; i < cyc_nodes.size(); i++) {
        curr_nodes[cyc_nodes[i]] = false;
        vector<int> keys = get_keys(reps[cyc_nodes[i]]);
        for(int j = 0; j < keys.size(); j++)  {
            reps[rep][keys[j]] = 0;
        }
    }
	
    chuLiuEdmonds(scoreMatrix,curr_nodes,oldI,oldO,final_edges,reps);
	
	
	
    // check each node in cycle, if one of its representatives
    // is a key in the final_edges, it is the one.
	
    int wh = -1;
    bool found = false;
	
    for(int i = 0; i < rep_cons.size() && !found; i++) {
        vector<int> keys = get_keys(rep_cons[i]);
        for(int j = 0; j < keys.size()&& !found; j++) {
            if(final_edges.find(keys[j])!=final_edges.end()) {
                wh = cyc_nodes[i];
                found = true;
            }
		}
		
	}
	
    int l = par[wh];
    while(l != wh) {
        int ch = oldO[par[l]][l];
        int pr = oldI[par[l]][l];
        final_edges[ch] = pr;
        l = par[l];
    }
	
	
	
    return final_edges;
	
	
	
}





static double** read_score_matrix(const char* const fname, const int n,
				  bool use_multiroot) {
	
	int i, j;
	
	ifstream in(fname);
	
	assert(in.good());
	
	/* we will need to add an extra row/column for the root node. */
	
	double** const rows = new double*[n+1];
	
	for(i = 0; i <= n; ++i) 
		rows[i] = new double[n+1]; 
	
	/* NB: the root-selection scores are stored on the diagonal */
	
	double* const row_root = rows[0];
	// Just to be on the safe side, start it up with something big...
	double sum_weights = 1e5;
	/* this won't get zeroed in the loop below */
//	row_root[0] = -HUGE_VAL;
	
	for(i = 0; i < n; ++i) {
		/* normal edges are all shifted by 1 */
		double* const row_i = rows[i+1];
		for(j = 0; j < n; ++j) {
			double tmp;
			assert(in.good());
			in >> tmp;
			if(i == j) { /* root-selection score */
			  sum_weights+= (tmp < 0 ? -tmp : tmp);
			  row_root[j+1] = tmp;
			  /* eliminate the diagonal (self-loops) and first column
			     (in-edges of root) */
			  row_i[j+1] = -HUGE_VAL;
			  row_i[0] = -HUGE_VAL;
			} 
			else      /* normal edge score */
			{
				row_i[j+1] = tmp;
				sum_weights+=tmp;
			}
		}
	}

	
	/* Find a constant to add to all the edges between the dummy root (node 0) and the rest so
	   as to make sure only one such edge is chosen. Set the constant to be MINUS the sum over
	   all the other weights.  do this only if single-root parsing is specified */
	if(!use_multiroot) {
	  for (i=0; i<n; ++i)
	    rows[0][i+1] -= sum_weights; 
	}
    in.close();

    return rows;

}



static void print_matrix(double** const A, const int n) {
	
	int i, j;
	
	for (i = 0; i < n; ++i) {
		
		const double* const A_i = A[i];
		
		for (j = 0; j < n; ++j) {
			
			printf("%.15g ", A_i[j]);
			
		}
		
		printf("\n");
		
	}
	
}





int main(int argc, char* argv[]) {
	
	if(argc < 3 || argc > 4) {
		
		cerr << "usage: " << argv[0] << " <matrix-file> <n> [multiroot]" << endl;
		
		return 1;
		
	}
	
	
	
	const int n = atoi(argv[2]);
	
	assert(n > 0);
	
	cout << n << endl;

	bool use_multiroot = false;
	if(argc == 4) {
	  if(strcmp(argv[3], "multiroot") == 0) {
	    use_multiroot = true;
	  } else {
	    cerr << "unknown option: \"" << argv[3] << "\"" << endl;
	    cerr << "usage: " << argv[0] << " <matrix-file> <n> [multiroot]" << endl;
	    return 1;
	  }
	}
	
	
	
	//    int numWords = 5;
	
    int numWords = n+1;
	
    int **oldI ;  // Should be double array of numWords*numWords
	
    int **oldO ; // Should be double array of numWords*numWords
	
	
	
    double **scoreMatrix;
	
    //    double **orig_scoreMatrix;
	
    vector<bool> curr_nodes = vector<bool>(numWords);
	
    TIntIntHashMap *reps = new TIntIntHashMap[numWords];
	
	
    
    scoreMatrix = read_score_matrix(argv[1], n, use_multiroot);
	
	
	
    //    orig_scoreMatrix = read_score_matrix(argv[1], n);
	
	
	
    oldI = new int* [numWords];
    oldO = new int* [numWords];
	
    //    scoreMatrix = new double* [numWords];
    //    orig_scoreMatrix = new double* [numWords];
	
    for (int j=0; j<numWords; j++) {
        oldI[j] = new int[numWords];
        oldO[j] = new int[numWords];
		//        scoreMatrix[j] = new double[numWords];
		//        orig_scoreMatrix[j] = new double[numWords];
    }
	
	
    for(int i = 0; i < numWords; i++) {
        curr_nodes[i] = true;
		//        reps[i] = new TIntIntHashMap(); JAVA
		// I think we don't need the above. Have already been initialized
		//        reps[i].put(i,0);  JAVA
        reps[i][i] = 0;
        for(int j = 0; j < numWords; j++) {
            // score of edge (i,j) i --> j
			//            scoreMatrix[i][j] = 1;
			//            orig_scoreMatrix[i][j] = 1;
            oldI[i][j] = i;
            oldO[i][j] = j;
			//            if(i == j || j == 0) continue; // no self loops of i --> 0
		}
    }
	
	
	
    TIntIntHashMap final_edges2; //I'm not sure if this is the same as final_edges returned
    // by chuLiuEdmonds or not
    print_matrix(scoreMatrix, numWords);
    TIntIntHashMap final_edges = chuLiuEdmonds(scoreMatrix,curr_nodes,oldI,oldO,final_edges2,reps);
	
    /* print out the max spanning tree */
	
    for(int i = 0; i < numWords; ++i) 
		cout << "parent(" << i << ") = " << final_edges[i] << endl;
    return 0;
	
}
